/*
 * Nomad Instrument Control Software
 *
 * Copyright 2011 Institut Laue-Langevin
 *
 * Licensed under the EUPL, Version 1.1 only (the "License");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 *
 * http://joinup.ec.europa.eu/software/page/eupl
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 */

#ifndef CADARACHEACQDEF_H
#define CADARACHEACQDEF_H

#include <common/base/BaseTypes.h>

namespace cadaracheacq {

static const uint32 VERSION_REGISTER = 0x10A0;
static const uint32 STATUS_REGISTER = 0x10A4;
static const uint32 ACTUAL_CHANNEL_REGISTER = 0x10A8;
static const uint32 ACTUAL_CYCLE_REGISTER = 0x10AC;
static const uint32 EVENT_IC_COUNTER_REGISTER = 0x10B0;
static const uint32 ACTUAL_TIME_REGISTER = 0x10BC;

static const uint32 NB_CHANNELS_REGISTER = 0x12B0;
static const uint32 NB_CYCLES_REGISTER = 0x12B4;

static const uint32 START_REGISTER = 0x1200;
static const uint32 CLEAR_RESULTS_REGISTER = 0x1210;
static const uint32 CLEAR_ALL_REGISTER = 0x1204;
static const uint32 CLEAR_MEMORIES_REGISTER = 0x1218;

static const uint32 GATE_EXT_STATUS = 0x1;
static const uint32 RUNNING_STATUS = 0x4;
static const uint32 FUNCTION_START_ACTIVE_STATUS = 0x10;
static const uint32 CLEAR_MEMORY_DATA_ACTIVE_STATUS = 0x40000000;
static const uint32 CLEAR_MEMORY_TIME_ACTIVE_STATUS = 0x80000000;

static const uint32 A32_ADDRESS = 0x01000000;
static const uint32 TIMES_MEMORY = 0x00000;
static const uint32 DATA_MEMORY = 0x40000;

}
#endif //CADARACHEACQDEF_H
